/* Copyright (c) 2009 The Regents of the Signet Group.
*  All rights reserved.
*
*  Permission to use, copy, modify, and distribute this software and its
*  documentation for any purpose, without fee, and without written
*  agreement is hereby granted, provided that the above copyright
*  notice, the (updated) modification history and the author appear in
*  all copies of this source code.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*  ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
*  BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, LOSS OF USE, DATA,
*  OR PROFITS) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
*  THE POSSIBILITY OF SUCH DAMAGE.
*/

#ifndef __SYNAPSE_H__
#define __SYNAPSE_H__

#define UQ_SYNAPSE_PARTITION_STORAGE "Synapse_PartitionStorage"

#define SNP_DATA_SIZE   	25
#define TOSH_DATA_LENGTH 	60 //better define this with a -D directive in the Makefile

#ifndef CC2420_DEF_RFPOWER
    #define CC2420_DEF_RFPOWER 	27
#endif

#define SYMBOLS_PER_BLOCK 	32 
#define SYMBOLS_PER_BLOCK_DIV8  4   		// ceil( SYMBOLS_PER_BLOCK / 8 )
#ifdef CHECK_BLOCK_CRC
#define CRC_SIZE	2
#else
#define CRC_SIZE    0
#endif
#define DISSEMINATION_BLOCK_TRESHOLD 1  //must be between 1 and  myAppBlocks
#define SYMBOLS_TO_SEND         36  
#define RECEIVER_SNP_BLOCK_SIZE     50  // >= SYMBOLS_PER_BLOCK

#define START_DEGREE_SEED          0xFA9B 
#define NUM_OF_SEEDS	35

#define GENERIC_DELAY  0x1 					//generic delay  for radio component in term of cycles

#define MIN(a,b) (a)<(b) ? (a) : (b)
#define CEIL(a,b) ((a)%(b)==0) ? ((a)/(b)) : ((a)/(b)+1)

/** ***************************************************************************
*  Internal Use only
*  Don't modify
*****************************************************************************/
#define SWAP_IN_PLACE
#define SYMBOL_SIZE     SNP_DATA_SIZE
#define PACKET_SIZE     SNP_DATA_SIZE
#define PCK_TO_SEND     SYMBOLS_TO_SEND
#define SNP_BLOCK_SIZE  (SYMBOLS_PER_BLOCK * SYMBOL_SIZE)     //in bytes
#define MAX_PCK_ARQ     (RECEIVER_SNP_BLOCK_SIZE-SYMBOLS_PER_BLOCK)
#define BLOCK_PAYLOAD_SIZE  (SYMBOLS_PER_BLOCK * SNP_DATA_SIZE - CRC_SIZE)
// Maximum number of blocks
#define MAX_BLOCKS		64
// Number of bytes needed to store a bitmask for the blocks 
#define MAX_BLOCKS_DIV8 8

#define MAX_CMD 			3
#define MAX_BACKOFF 		16
#define ADV_DELAYED_LIMIT 	3

#endif //__SYNAPSE_H__
